#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include "camview.h"
#include "callbacks.h"
#include "interface.h"
#include "support.h"


void
on_start_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *stop;
	GtkWidget *image;
	stop = lookup_widget (GTK_WIDGET(button),"stop");
	image = lookup_widget (GTK_WIDGET(button),"image1");
	start_cam(GTK_IMAGE(image));
	gtk_widget_set_sensitive (GTK_WIDGET(button), 0);
	gtk_widget_set_sensitive (GTK_WIDGET(stop), 1);
}

void start_cam ( GtkImage *image ) {
        g_spawn_command_line_async (cam_cmdline, NULL);
        gtk_timeout_add (1000,load_camera_image,image);
	state = 1;
	gtk_image_set_from_pixbuf(GTK_IMAGE(icon_pix),
					tray_icon_display (state));
}

void
on_stop_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *start;
	gtk_timeout_remove (timer_id);
	start = lookup_widget (GTK_WIDGET(button),"start");
	stop_cam();
	gtk_widget_set_sensitive (GTK_WIDGET(button), 0);
	gtk_widget_set_sensitive (GTK_WIDGET(start), 1);
}

void stop_cam (void) {
	system ("killall -15 webcam");
	state = 0;
	gtk_image_set_from_pixbuf(GTK_IMAGE(icon_pix)
					,tray_icon_display(state));
}

void
on_hide_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *mainwindow = lookup_widget(GTK_WIDGET(button),"mainwindow");
	visible = 0;
	gtk_widget_hide_all (mainwindow);
}

