/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include "camview.h"
#include <gnome.h>
#include "eggtrayicon.h"
#include "prefs.h"
#include "interface.h"
#include "support.h"

int main (int argc, char *argv[])
{
  GnomeClient *client;
  GtkWidget *mainwindow;
  GtkWidget *start, *stop;
  GtkWidget *icon;
  GtkWidget *icon_box;
  GdkPixbuf *pixbuf;
#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
                      argc, argv,
                      GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR,
                      NULL);
  client = gnome_master_client ();
  g_signal_connect (client, "save-yourself", G_CALLBACK(save_session), (gpointer) argv[0]);
  get_prefs();
  state = start_on;
  mainwindow = create_mainwindow ();
  image = GTK_IMAGE(lookup_widget (GTK_WIDGET(mainwindow),"image1"));
  start = lookup_widget (GTK_WIDGET(mainwindow),"start");
  stop = lookup_widget (GTK_WIDGET(mainwindow),"stop");
  gtk_widget_set_sensitive(start, 1);
  gtk_widget_set_sensitive(stop, 0);
  load_camera_image (image);
  icon = GTK_WIDGET(egg_tray_icon_new ("camview tray icon"));
  icon_box = gtk_event_box_new ();
  g_signal_connect (G_OBJECT(icon_box), "button_press_event", 
			G_CALLBACK(tray_icon_clicked), NULL);
  gtk_container_add (GTK_CONTAINER(icon), icon_box);
  icon_pix = gtk_image_new_from_pixbuf(tray_icon_display (state));
  gtk_container_add(GTK_CONTAINER(icon_box),icon_pix); 
  gtk_widget_show_all(icon);
  if (start_hidden == 0) {
	  gtk_widget_show (mainwindow);
  }
  if (state == 1) {
	on_start_clicked(GTK_BUTTON(start),NULL);
  }
  gtk_main ();
  return 0;
}

gboolean load_camera_image (gpointer image) {
	if (g_file_exists(local_file)) {
		gtk_image_set_from_file (GTK_IMAGE(image),local_file);
	} else {
		gtk_image_set_from_file (GTK_IMAGE(image),
				gnome_pixmap_file( "camview/test_card.jpg"));
	}
	return 1;
}

GdkPixbuf * tray_icon_display ( gint state ) {
	GdkPixbuf *pixbuf;
	if (state == 0) {
		pixbuf = create_pixbuf("camview/cam_off.png");
	} else {
		pixbuf = create_pixbuf("camview/cam_on.png");
	}
	return pixbuf;
};

void tray_icon_clicked ( GtkWidget *event_box, GdkEventButton *event, gpointer data ) {
	GtkWidget *main = lookup_widget(GTK_WIDGET(image),"mainwindow");
	GtkWidget *start = lookup_widget(GTK_WIDGET(image),"start");
	GtkWidget *stop = lookup_widget(GTK_WIDGET(image),"stop");

	if (event->type != GDK_BUTTON_PRESS) {
		return;
	}

	if (event->button == 1) {
		if (visible == 0) {
			gtk_widget_show_all (main);
			visible=1;
		} else {
			gtk_widget_hide_all (main);
			visible=0;
		}
	}

	if (event->button == 3) {
		if (state == 0) {
			start_cam(image);
			gtk_widget_set_sensitive(start,0);
			gtk_widget_set_sensitive(stop,1);
		} else {
			stop_cam();
			gtk_widget_set_sensitive(start,1);
			gtk_widget_set_sensitive(stop,0);
		}
	}
}

                                                                               
static int save_session(GnomeClient        *client,
             gint                phase,
             GnomeRestartStyle   save_style,
             gint                shutdown,
             GnomeInteractStyle  interact_style,
             gint                fast,
             gpointer            client_data)
{
                                                                                
    gchar *argv[]= { NULL };
                                                                                
    argv[0] = (gchar*) client_data;
    gnome_client_set_clone_command (client, 1, argv);
    gnome_client_set_restart_command (client, 1, argv);
                                                                                
    return TRUE;
}                                                                               

